2017 Multi-University Training Contest - Team 6 HDU 6105 Gameia(博弈)
题目链接:
HDU 6105 Gameia
题目大意:
给一棵树,
n
个点,
解题思路:
- 首先要知道, B的机会, 如果他要用,那么可以视为在最刚开始就用。
- 然后是博弈的问题, 比赛的时候学长在写6103字符串那题, 我就在旁边推这个博弈, 画了几个图发现, 对于一条链来说, 只有长度为2的时候B才必胜, 因为链长度为
1,3,4.
A必胜,如果长度大于4, 那么A一定可以通过染最边上或者边上的第二个使得这条链以
−2,或者−3
的长度缩减, 最终变成长度为
3或4
, 这样又变成了A必胜。 这里不理解的可以自己画一下, 因为AB都绝对聪明, 而且A先手。
对于一棵树来说, 也是如此, 并且在树上A更占优势, 因为有很多分支点。 所以我就想把这棵树切成两两一段。 看需要次数是否超过k, 还要判断存在切完之后是否存在单点的情况。(如果存在单点, A点一下必胜)。
代码:
/**********************************************
*Author* :ZZZZone
*reated Time* : 2017/8/10 14:29:50
*ended Time* : 2017/8/10 14:41:02
*********************************************/
#include <cstdio>
#include <cstring>
#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <string>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <stack>
using namespace std;
typedef pair<int, int> PII;
typedef long long LL;
typedef unsigned long long ULL;
const int MaxN = 500;
int n, k, tot;
int all, pre[2 * MaxN + 5], last[MaxN + 5], other[2 * MaxN + 5];
bool ok, vis[MaxN + 5];
int ind[MaxN + 5];
void Build(int x, int y) {
pre[++all] = last[x];
last[x] = all;
other[all] = y;
}
void Dfs(int x, int fa) {
int ed = last[x];
int cnt = 0;
while(ed != -1) {
int dr = other[ed];
if(dr != fa) {
Dfs(dr, x);
if(ind[dr] > 0 || ind[x] > 0) tot++;
else ind[dr]++, ind[x]++;
}
ed = pre[ed];
}
}
int main()
{
int T;
scanf("%d", &T);
while(T--) {
all = -1; memset(last, -1, sizeof(last));
memset(vis, 0, sizeof(vis));
memset(ind, 0, sizeof(ind));
scanf("%d%d", &n, &k);
for(int i = 2; i <= n; i++) {
int x;
scanf("%d", &x);
Build(x, i); Build(i, x);
}
ok = 1; tot = 0;
Dfs(1, 0);
for(int i = 1; i <= n; i++) if(ind[i] == 0) ok = 0;
if(tot > k) ok = 0;
if(ok) printf("Bob\n");
else printf("Alice\n");
}
return 0;
}